unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, stdctrls;

type

  TMyEdit = class(TEdit)
  private
  protected
    procedure Change; override;
    procedure WMPaste(var Message: TMessage); message WM_PASTE;
    procedure WndProc(var Message: TMessage); override;
  public
    MemoLog: TMemo;
    CallInherited: Boolean;
  end;

  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TMyEdit }

procedure TMyEdit.Change;
begin
  MemoLog.Lines.Add('Change Text:' + Text);
  inherited;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  with TMyEdit.Create(Self) do
  begin
    Parent := Self;
    MemoLog := Memo1;
    //CallInherited := True;
  end;
end;

procedure TMyEdit.WMPaste(var Message: TMessage);
begin
  inherited;
end;

procedure TMyEdit.WndProc(var Message: TMessage);
var
  S: String;
begin
  case Message.Msg of
    WM_CLEAR,
    WM_CUT,
    WM_PASTE,
    WM_COPY:
      begin
         case Message.Msg of
    WM_CLEAR: S := 'WM_CLEAR';
    WM_CUT: S := 'WM_CUT';
    WM_PASTE: S := 'WM_PASTE';
    WM_COPY: S := 'WM_COPY';
         end;
         MemoLog.Lines.Add( S + '(Before) Text:' + Text);
         if CallInherited then
           inherited;
         MemoLog.Lines.Add(S + '(After) Text:' + Text);
      end;
    else
      inherited WndProc(Message);
  end;
end;

end.
